{*****************************************************************************}
{  DDObjects                                            www.delphi-online.at  }
{  Copyright (C) 2006 Stefan Meisner, stefan.meisner@gmx.net                  }
{  This software is distributed as shareware. It is NOT free. You may use     }
{  the software for a trial period of thirty (30) days, at no cost to you,    }
{  to determine if it fits your needs. If you decide to use the software,     }
{  you shall register it and pay the applicable registration fee.             }
{  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    }
{  OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABI-    }
{  LITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT OF THIRD PARTY  }
{  RIGHTS. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR   }
{  ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,   }
{  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFT-    }
{  WARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         }
{*****************************************************************************}

program DDObjectsTests;

{$APPTYPE Console}

{$I DDObjectsTests.inc}

uses
  {$IFDEF DDServer}DDSMemory, DDSMainForm, DDSAccess, {$ENDIF}
  SysUtils,
  Forms,
  TestFramework,
  TextTestRunner,
  GUITestRunner,
  DDOCommonTests in 'DDOCommonTests.pas',
  DDOTestTypes in 'DDOTestTypes.pas',
  DDODocumentTests in 'DDODocumentTests.pas',
  DDOTestExtensions in 'DDOTestExtensions.pas',
  DDOBasicRemoteTests in 'DDOBasicRemoteTests.pas',
  DDOStatefullTests in 'DDOStatefullTests.pas',
  DDOSessionTests in 'DDOSessionTests.pas',
  DDOTestForm in 'DDOTestForm.pas' {TestForm};

{$R *.RES}

var
  testResult: TTestResult;
{$IFDEF BurnInTest}
  guiTestForm: TGUITestRunner;
  lStart: TDateTime;

const
  CBurnInDuration = 12;  // duration in hours
{$ENDIF}

begin
  if FindCmdLineSwitch('c', ['-'], true) then
  begin
    testResult := TextTestRunner.RunRegisteredTests(rxbContinue);
    ExitCode := testResult.ErrorCount + testResult.FailureCount;
  end else
  begin
    Application.Initialize;
    {$IFDEF DDServer}
      {$IFNDEF MemoryTests}
        TDDSMainForm.GetInstance.Show;
        DDSHandler.MemoryProfiler.DefaultFilter.OtherThreads := True;
      {$ENDIF}
    {$ENDIF}
    GUITestRunner.RunRegisteredTestsModeless;
    {$IFDEF BurnInTest}
      DDSHandler.MemoryProfiler.Active := True;
      guiTestForm := Application.MainForm as TGUITestRunner;
      lStart := Now;
      while lStart + (CBurnInDuration / 24) > Now do
        guiTestForm.RunAction.Execute;
    {$ENDIF}
    Application.Run;
  end;
end.
