{*****************************************************************************}
{  DDObjects                                            www.delphi-online.at  }
{  Copyright (C) 2006 Stefan Meisner, stefan.meisner@gmx.net                  }
{  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    }
{  OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABI-    }
{  LITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT OF THIRD PARTY  }
{  RIGHTS. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR   }
{  ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,   }
{  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFT-    }
{  WARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         }
{*****************************************************************************}

unit uMainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, uServerBaseForm, DDOServer, ComCtrls, StdCtrls, Spin, Buttons,
  DDOBroker, DDOBase, DDODataGrid, DDOProgressBar, DDOUtils, ExtCtrls;

type
  TBrokerMainForm = class(TServerBaseForm)
    DDOBroker1: TDDOBroker;
    procedure SpeedButtonStartClick(Sender: TObject);
    procedure HandleRequest(Sender: TObject; var Data: String);
    procedure HandleServerConnect(Sender: TObject; Server: TServerItem);
    procedure HandleClientConnect(Sender: TObject; Client: TDDOBrokerThread);
    procedure GridThreadsGetData(Sender: TObject; Index: Integer;
      var Value: Integer);
    procedure FormCreate(Sender: TObject);
  protected
    procedure UpdateGUI; override;
  end;

var
  BrokerMainForm: TBrokerMainForm;

implementation

{$R *.dfm}

//----------------------------------------------------------------------------
//2006-13-02 N,SM:

procedure TBrokerMainForm.UpdateGUI;
begin
  with DDOBroker1, StatusBar1 do
  begin
    SpeedButtonStart.Down := Active;
    EditPort.Enabled := not Active;
    EditPort.Value := Port;
    Panels[0].Text := 'cln: ' + IntToStr(ClientConnections);
    Panels[1].Text := 'thr: ' + IntToStr(ClientThreads);
    Panels[2].Text := 'srv: ' + IntToStr(ServerCount);
    Panels[3].Text := 'wrk: ' + IntToStr(ServerConnections);
    Panels[4].Text := 'req: ' + IntToStr(FRequests);
  end;
end;

//----------------------------------------------------------------------------
//2006-13-02 N,SM:

procedure TBrokerMainForm.SpeedButtonStartClick(Sender: TObject);
begin
  try
    if not DDOBroker1.Active then
      DDOBroker1.Port := EditPort.Value;
    DDOBroker1.Active := not DDOBroker1.Active;
  finally
    UpdateGUI;
  end;
end;

//----------------------------------------------------------------------------
//2006-13-02 N,SM:

procedure TBrokerMainForm.HandleClientConnect(Sender: TObject;
  Client: TDDOBrokerThread);
begin
  RequestUpdate;
end;

//----------------------------------------------------------------------------
//2006-13-02 N,SM:

procedure TBrokerMainForm.HandleServerConnect(Sender: TObject;
  Server: TServerItem);
begin
  RequestUpdate;
end;

//----------------------------------------------------------------------------
//2006-13-02 N,SM:

procedure TBrokerMainForm.HandleRequest(Sender: TObject;
  var Data: String);
begin
  Inc(FRequests);
  RequestUpdate;
end;

//----------------------------------------------------------------------------
//2006-02-21 N,SM:

procedure TBrokerMainForm.GridThreadsGetData(Sender: TObject;
  Index: Integer; var Value: Integer);
begin
  Value := DDOBroker1.ClientThreads;
end;

//----------------------------------------------------------------------------
//2006-02-27 N,SM:

procedure TBrokerMainForm.FormCreate(Sender: TObject);
begin
  inherited;
  TabSheet2.TabVisible := False;
end;

end.
