{*****************************************************************************}
{  DDObjects                                            www.delphi-online.at  }
{  Copyright (C) 2006 Stefan Meisner, stefan.meisner@gmx.net                  }
{  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    }
{  OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABI-    }
{  LITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT OF THIRD PARTY  }
{  RIGHTS. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR   }
{  ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,   }
{  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFT-    }
{  WARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         }
{*****************************************************************************}

unit uServerMainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, uDemoClient, uPersistentDemo_Stub, uServerBaseForm, DDOBase,
  DDOServer, DDODataGrid, ComCtrls, StdCtrls, Spin, Buttons, DDOProgressBar,
  ExtCtrls;

type
  TServerMainForm = class(TServerBaseForm)
    procedure FormCreate(Sender: TObject);
  end;

  TPersistentDemo = class(TPersistentDemo_Stub)
  private
    FClient: TDemoClient;
  public
    procedure GetClient(ClientID: Integer; out Client: TObject); override;
    procedure SetClient(Client: TObject); override;
    procedure Initialize; override;
    destructor Destroy; override;
  end;

var
  ServerMainForm: TServerMainForm;

implementation

{$R *.dfm}

//----------------------------------------------------------------------------
//2006-02-20 N,SM:

destructor TPersistentDemo.Destroy;
begin
  FreeAndNil(FClient);
  inherited;
end;

//----------------------------------------------------------------------------
//2006-02-20 N,SM:

procedure TPersistentDemo.GetClient(ClientID: Integer;
  out Client: TObject);
begin
  Client := FClient;
end;

//----------------------------------------------------------------------------
//2006-02-20 N,SM:

procedure TPersistentDemo.Initialize;
begin
  inherited;
  FClient := TDemoClient.Create(6666);
  with FClient do
  begin
    Name := 'Stefan Meisner';
    EMail := 'stefan.meisner@gmx.net';
    URL := 'www.delphi-online.at';
    Info.Text := 'This is some sample text' + #13#10 + '...tralala';
  end;
end;

//----------------------------------------------------------------------------
//2006-02-20 N,SM:

procedure TPersistentDemo.SetClient(Client: TObject);
begin
  FClient.Assign(Client as TDemoClient);
end;

//----------------------------------------------------------------------------
//2006-02-20 N,SM:

procedure TServerMainForm.FormCreate(Sender: TObject);
begin
  inherited;
  DDOListener1.RegisterClass(TPersistentDemo);
end;

end.
