 // ************************************************************
 //  This unit has been created using DDOWizard 1.0
 //  Do not modify this code as it will be overridden whenever
 //  the definition changes or code generation has been started
 //  Last update: 05.03.2007 23:07:31
 // ************************************************************

unit uDemoClass_ProxyDelegate;

{$HINTS OFF}

interface

uses
  DDOShared, Controls, DDOVariants, Classes, TypInfo, SysUtils, 
  DDOBase, DDOTypeInfos, DDOConsts, DDOLang, DDOClient;

type
  TAsyncInvokeEvent = procedure (Sender: TDDOProxyBase; GUID: String; Data: String) of object;
  TNotificationEvent = procedure (Sender: TDDOProxyBase; GUID: String) of object;

type
  TDemoClassDelegate = class(TDDOProxyDelegateBase)
  private
    procedure _AsyncInvoke(GUID: String; Callback: TMethod);
    procedure _Notification(GUID: String; Callback: TMethod);
  protected
    function IsCachedRequest(const MethodName: string): Boolean; override;
    procedure DispatchCall(const GUID: String; Method: TMethod; ADispID: Integer); override;
  public
    procedure GetQuote(out Quote: String);
    procedure GetTime(out Time: TDateTime);
    procedure GetVarParam(var Param: String);
    function AsyncInvoke(ID: Integer; Callback: TAsyncInvokeEvent): String;
    procedure GetSessionData(out Data: String);
    procedure SetSessionData(Data: String);
  public
    class function GetVersion: String; override;
  end;

implementation

var
  _TypeData: TStrings;

procedure CollectTypeInfos;
begin
  BeginCollectTypeInfos;
  try
  finally
    _TypeData := DoneCollectTypeInfos;
  end;
end;

class function TDemoClassDelegate.GetVersion: String;
begin
  Result := '{EE91CBBF-2C15-4A63-9920-B82716EE66BF}';
end;

function TDemoClassDelegate.IsCachedRequest(const MethodName: string): Boolean;
begin
  Result := False
end;

procedure TDemoClassDelegate.DispatchCall(const GUID: String; Method: TMethod; ADispID: Integer);
begin
  inherited;
  case ADispID of
    -1: ; // dummy;
    3: _AsyncInvoke(GUID, Method);
    4: _Notification(GUID, Method);
  else
    raise EDDOError.CreateResFmt(@SImplementationNotFound, [ADispID]);
  end;
end;

procedure TDemoClassDelegate.GetQuote(out Quote: String);
begin
  PrepareCall('GetQuote');
  SendRequest;
  Quote := GetParam('Quote', False);
end;

procedure TDemoClassDelegate.GetTime(out Time: TDateTime);
begin
  PrepareCall('GetTime');
  SendRequest;
  Time := GetParam('Time', True);
end;

procedure TDemoClassDelegate.GetVarParam(var Param: String);
begin
  PrepareCall('GetVarParam');
  SetParam('Param', Param, False);
  SendRequest;
  Param := GetParam('Param', False);
end;

procedure TDemoClassDelegate._AsyncInvoke(GUID: String; Callback: TMethod);
var
  Data: String;
begin
  Data := GetParam('Data', False);
  TAsyncInvokeEvent(Callback)(Originator, GUID, Data);
end;

function TDemoClassDelegate.AsyncInvoke(ID: Integer; Callback: TAsyncInvokeEvent): String;
begin
  PrepareCall('AsyncInvoke');
  SetParam('ID', ID, False);
  Result := AddEvent(SendAsyncRequest, TMethod(Callback), 3);
end;

procedure TDemoClassDelegate._Notification(GUID: String; Callback: TMethod);
begin
  TNotificationEvent(Callback)(Originator, GUID);
end;

procedure TDemoClassDelegate.GetSessionData(out Data: String);
begin
  PrepareCall('GetSessionData');
  SendRequest;
  Data := GetParam('Data', False);
end;

procedure TDemoClassDelegate.SetSessionData(Data: String);
begin
  PrepareCall('SetSessionData');
  SetParam('Data', Data, False);
  SendRequest;
end;


initialization
  CollectTypeInfos;

finalization
  FreeAndNil(_TypeData);

end.
